/*  Program.....: jsScore.js
    Programmer..: Michael Thomas  michael@michael-thomas.com

    Description:
      1.  Total all of the scores from Coursebuilder on a page.
      2.  Create total time.
      3.  List questions not completed.
*/

dateStartTest = new Date();  //WARNING: cannot be a var !!!! CourseBuilder Action Objects!!!
var intTotalSeconds = 0;
var strMsgQuestNotCompleted = "";
var aQuestInfo = new Array();
var QuestCalc = new fcQuestCalc();
var blnAllDisabled = false;

//************************************************************************************
function fQuestCalc(objWin) {
//************************************************************************************
  
  QuestCalc = new fcQuestCalc();

  fQuestBuild(objWin);  //Build the array:  aQuestInfo & set QuestCalc.blnAllDisabled

  if ( QuestCalc.blnAllDisabled ) {
    QuestCalc.strMsqQuestNotCompleted = "";
  } else {
    QuestCalc.strMsqQuestNotCompleted = fQuestDisabledMsg(objWin); //Build not completed message.
  }

  for( var x=0; x < aQuestInfo.length; x++ ) {
    
    QuestCalc.intTotalQuestions++;

    if ( aQuestInfo[x].blnCorrect ) {
      QuestCalc.intTotalCorrect++;    
    }

    QuestCalc.intTotalScore += aQuestInfo[x].intScore;

  }//for

  QuestCalc.intTotalCorrectPercent = Math.round( ( QuestCalc.intTotalCorrect / QuestCalc.intTotalQuestions ) * 100 )
  QuestCalc.strTotalCorrectPercent = ( QuestCalc.intTotalCorrectPercent + "%" );

  QuestCalc.dateStartTest = dateStartTest;
  QuestCalc.dateStopTest  = new Date();
  QuestCalc.intTotalTime = ( QuestCalc.dateStopTest - QuestCalc.dateStartTest );
  QuestCalc.intTotalSeconds = Math.round(( QuestCalc.intTotalTime / 1000 ));

}

function fcQuestCalc () {

  this.intTotalQuestions        = 0;
  this.intTotalCorrect          = 0;
  this.intTotalCorrectPercent   = 0;
  this.strTotalCorrectPercent   = "";
  this.intTotalScore            = 0;
  this.strMsgQuestNotCompleted  = "";
  this.blnAllDisabled           = false;
  this.dateStarted              = dateStartTest;
  this.dateStoped               = dateStartTest; //Same for now.
  this.intTotalTime             = 0;
  this.intTotalSeconds          = 0;

}

//************************************************************************************
function fQuestBuild(objWin) {
//************************************************************************************
  var intIndex = 0;

  QuestCalc.blnAllDisabled = true;
  aQuestInfo               = new Array();

  for ( i in objWin ) {
  	
    if ( i.substring(0,2) == "'G" ) {

      var strObjName = i.replace("'","").replace("'","");
      var objCB = eval(strObjName);
      
      if ( typeof objCB.disabled != "boolean" || ! objCB.disabled  ) {

        if ( objCB.trackIntId.toLowerCase().indexOf("finished") >= 0 ||
             objCB.trackIntId.toLowerCase().indexOf("skip") >= 0 ) {
          //This is an action manager object with an Interaction ID == "finished" or "skip";
        } else {

    	    QuestCalc.blnAllDisabled = false; //A question is not completed.

        }
      }
        if ( objCB.trackIntId.toLowerCase().indexOf("finished") >= 0 ||
             objCB.trackIntId.toLowerCase().indexOf("skip") >= 0 ) {
          //Skip this one.  This is an ActionManager
        } else {
          aQuestInfo[intIndex] = 
              new fcQuestStatus(strObjName, 
                                objCB );
          intIndex++;
        }
    }
  } //for
}

//************************************************************************************
function fQuestDisabledMsg(objWin) {
//************************************************************************************
//Note: .disabled -  0-number,           if not disabled
//                   true-boolean,       if disabled.
//      .correct  -  0-number or Object, if not finished answering the question.
//                   true-boolean,       if correct.
//                   false-boolean,      if wrong.

var strMsg = "";
var intIndex = 0;

  strMsg = "";
  strMsg += "Sorry, you have not answered all of the questions on this page. \n\n";
  strMsg += "Please answer the following questions:\n\n";

  for( var x=0; x < aQuestInfo.length; x++ ) {

    if ( aQuestInfo[x].blnDisabled ) { 

       strMsg += '' + aQuestInfo[x].strQuestName.toUpperCase() + ' - ' + 
                  'Completed. ' +
                  '' + '\n';
      
    } else {

      //  This works, but does not match what can be done with outlinequest2       
      //  strMsg += '' + aQuestInfo[x].strQuestName + ' - ' + 
      //            'You attempted to answer the question ' + 
      //            aQuestInfo[x].intTries + ' out of ' + aQuestInfo[x].intTriesLimit + 
      //            " times." +
      //            '' + '\n';

      if ( aQuestInfo[x].intTries == 0 ) {

        strMsg += '' + aQuestInfo[x].strQuestName.toUpperCase() + ' - ' + 
                  'You have not attempted to answer the question. ' +
                  '' + '\n';
       
      } else {

        strMsg += '' + aQuestInfo[x].strQuestName.toUpperCase() + ' - ' + 
                  'Try answering the question again.  You still have some tries left.' +
                  '' + '\n';
      }

    }//big if

  }//for


  //alert( strMsg );

return strMsg;
  
}
//*******************************************************************************************
function fcQuestStatus(strKnowledgeName, objCB ) {
//*******************************************************************************************

  this.strKnowledgeName =  strKnowledgeName;
  this.strQuestName     =  objCB.trackIntId;   
  this.strObjectiveName =  objCB.trackObjectiveId;   
  this.blnDisabled      =  (typeof objCB.disabled  == "boolean" ? objCB.disabled : false);
  this.intTries         =  objCB.tries;       
  this.blnTriesAtLimit  =  objCB.triesAtLimit;   
  this.intTriesLimit    =  objCB.triesLimit;   
  this.blnCorrect       =  objCB.correct; //Multi-types: number, null, boolean.
  this.intScore         =  objCB.score;
                                                                
}
